// BruchAddierer.java                               MM 2015

/**
 * Addierer fuer gemeine Brueche.
 */
public class BruchAddierer
{
/* ------------------------------------------------------*/
                                                // coreData
/**
 * Ergebnisbruch.
 */
  private Bruch ergebnis;

/**
 * Bruchoperand.
 */
  private Bruch operand;

/* ----------------------------------------------------- */
                                             // Konstruktor
/**
 * Konstruktor, setzt Startwerte auf 0/1.
 */
  public BruchAddierer()
  {
    reset();
  }


/* ------------------------------------------------------*/
                                        // getData-Methoden

/* ----------------------------------------------------- */
                                        // Service-Methoden
/**
 * Setzen eines neuen Operandennenner.
 * @param n Nenner
 * @throws BruchException
 */
  public void setOperandNenner( int n)
    throws Exception
  {
    operand.setNenner( n);
  }

/**
 * Setzen eines neuen Operandenzaehler.
 * @param z Zaehler
 */
  public void setOperandZaehler( int z)
  {
    operand.setZaehler( z);
  }

/**
 * Startzustand, loeschen von Bruch und Operand.
 */
  public void reset()
  {
    ergebnis = new Bruch( 0);
    operand = new Bruch( 0);
  }

/**
 * Addition, Bruch = Bruch + Operand.
 * @throws BruchException, NPlusException
 */
  public void addiere()
    throws Exception
  {
    ergebnis = ergebnis.add( operand);
    operand = new Bruch( 0);
  }

/* ----------------------------------------------------- */
/**
 * Darstellung des Ergebnisbruchs.
 */
  public String toString()
  {
    return ergebnis.toString();
  }

/* ----------------------------------------------------- */
/* ----------------------------------------------------- */
/**
 * Testprogramm zur Klasse BruchAddiererModel.
 * Aufgabe: 1/2+1/2+1/2+2/3=13/6
 */
  public static void main( String[] args)
  {
    try
    {
      BruchAddierer addierer = new BruchAddierer();

// Startwerte
      System.out.println( "Start: " + addierer);

// Aufgabe
      System.out.println
      ( "Aufgabe: 1/2 + 1/2 + 1/2 + 2/3 =");

      addierer.setOperandZaehler( 1);
      addierer.setOperandNenner( 2);
      addierer.addiere();
      System.out.println( addierer);

      addierer.setOperandZaehler( 1);
      addierer.setOperandNenner( 2);
      addierer.addiere();
      System.out.println( addierer);

      addierer.setOperandZaehler( 1);
      addierer.setOperandNenner( 2);
      addierer.addiere();
      System.out.println( addierer);

      addierer.setOperandZaehler( 2);
      addierer.setOperandNenner( 3);
      addierer.addiere();
      System.out.println( addierer);

      System.out.println( "Ergebnis: " + addierer);
    }
    catch( Exception e)
    {
      System.out.println( "Fehler: " + e);
    }
  }
}
